
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  15. Dec 2009  15:39  *************

	processor  16F87
	radix  DEC

Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
  EXTERN Flackerlichter0
  EXTERN Flackerlichter1
  EXTERN Flackerlichter2
  EXTERN Flackerlichter3
  EXTERN Flackerlichter5
  EXTERN Flackerlichter7
  EXTERN Flackerlichter8
  EXTERN Flackerlichter9
  EXTERN Flackerlichter10
  EXTERN Flackerlichter11
  EXTERN Flackerlichter12
  EXTERN TagesZaehler

BANK1    UDATA
PWM_Zaehler_Kerzen RES   1
  GLOBAL PWM_Zaehler_Kerzen
Gleichheitszaehler_Kerzen RES   1
  GLOBAL Gleichheitszaehler_Kerzen
TabZaehlerTagB RES   1
  GLOBAL TabZaehlerTagB
TabZaehlerTagC RES   1
  GLOBAL TabZaehlerTagC
TabZaehlerTagD RES   1
  GLOBAL TabZaehlerTagD
TabZaehlerTagE RES   1
  GLOBAL TabZaehlerTagE
TabZaehlerTagF RES   1
  GLOBAL TabZaehlerTagF
TabZaehlerTagG RES   1
  GLOBAL TabZaehlerTagG
TabZaehlerTagH RES   1
  GLOBAL TabZaehlerTagH
TabZaehlerTagI RES   1
  GLOBAL TabZaehlerTagI
TabZaehlerTagJ RES   1
  GLOBAL TabZaehlerTagJ
TabZaehlerTagK RES   1
  GLOBAL TabZaehlerTagK
TabZaehlerTagL RES   1
  GLOBAL TabZaehlerTagL
TabZaehlerTagM RES   1
  GLOBAL TabZaehlerTagM
TabZaehlerTagN RES   1
  GLOBAL TabZaehlerTagN
TabZaehlerTagO RES   1
  GLOBAL TabZaehlerTagO
TabZaehlerTagP RES   1
  GLOBAL TabZaehlerTagP
TabZaehlerTagQ RES   1
  GLOBAL TabZaehlerTagQ
TabZaehlerTagR RES   1
  GLOBAL TabZaehlerTagR
TabZaehlerTagS RES   1
  GLOBAL TabZaehlerTagS
TabZaehlerTagT RES   1
  GLOBAL TabZaehlerTagT
TabZaehlerTagU RES   1
  GLOBAL TabZaehlerTagU
TabZaehlerTagV RES   1
  GLOBAL TabZaehlerTagV
TabZaehlerTagW RES   1
  GLOBAL TabZaehlerTagW
TabZaehlerTagX RES   1
  GLOBAL TabZaehlerTagX
TabZaehlerTagY RES   1
  GLOBAL TabZaehlerTagY
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F

BANK2    UDATA
PWM_LED_TagB RES   1
  GLOBAL PWM_LED_TagB
PWM_LED_TagC RES   1
  GLOBAL PWM_LED_TagC
PWM_LED_TagD RES   1
  GLOBAL PWM_LED_TagD
PWM_LED_TagE RES   1
  GLOBAL PWM_LED_TagE
PWM_LED_TagF RES   1
  GLOBAL PWM_LED_TagF
PWM_LED_TagG RES   1
  GLOBAL PWM_LED_TagG
PWM_LED_TagH RES   1
  GLOBAL PWM_LED_TagH
PWM_LED_TagI RES   1
  GLOBAL PWM_LED_TagI
PWM_LED_TagJ RES   1
  GLOBAL PWM_LED_TagJ
PWM_LED_TagK RES   1
  GLOBAL PWM_LED_TagK
PWM_LED_TagL RES   1
  GLOBAL PWM_LED_TagL
PWM_LED_TagM RES   1
  GLOBAL PWM_LED_TagM
PWM_LED_TagN RES   1
  GLOBAL PWM_LED_TagN
PWM_LED_TagO RES   1
  GLOBAL PWM_LED_TagO
PWM_LED_TagP RES   1
  GLOBAL PWM_LED_TagP
PWM_LED_TagQ RES   1
  GLOBAL PWM_LED_TagQ
PWM_LED_TagR RES   1
  GLOBAL PWM_LED_TagR
PWM_LED_TagS RES   1
  GLOBAL PWM_LED_TagS
PWM_LED_TagT RES   1
  GLOBAL PWM_LED_TagT
PWM_LED_TagU RES   1
  GLOBAL PWM_LED_TagU
PWM_LED_TagV RES   1
  GLOBAL PWM_LED_TagV
PWM_LED_TagW RES   1
  GLOBAL PWM_LED_TagW
PWM_LED_TagX RES   1
  GLOBAL PWM_LED_TagX
PWM_LED_TagY RES   1
  GLOBAL PWM_LED_TagY
_LcAA       RES   1
  GLOBAL _LcAA
RD          EQU   0
EEPGD       EQU   7

  ; FILE FLACKERLICHT_KERZEN.C
			;/***************************************************************************************/
			;/* Unterprogramme zur Erzeugung des Flackerlichts (fuer die Kerzen) mit Hilfe einer    */
			;/* Tabelle                                                                             */
			;/*                                                                                     */
			;/* Compiler: CC5X                                                                      */
			;/*                                                                                     */
			;/* Entwickler: Buchgeher Stefan                                                        */
			;/* Entwicklungsbeginn der Software: 27. September 2008                                 */
			;/* Funktionsfaehig seit: 27. September 2008                                            */
			;/* Letzte Bearbeitung: 21. Juni 2009                                                   */
			;/***************************************************************************************/
			;
			;/****************** Include-Dateien ****************************************************/
			;#include "PROJEKT.H"
			; 
			;
			;/****************** Globale Register ***************************************************/
			;#pragma rambank 1
			;
			;char    PWM_Zaehler_Kerzen;     	// Hilfszaehler zur Erzeugung der PWM
			;char    Gleichheitszaehler_Kerzen;    	// mehrere gleiche PWMs nacheinander
			;
			;char    TabZaehlerTagB;         	// Tabellen-Zeiger fuer Tag B (Kerze)
			;char    TabZaehlerTagC;         	// Tabellen-Zeiger fuer Tag C (Kerze)
			;char    TabZaehlerTagD;         	// Tabellen-Zeiger fuer Tag D (Kerze)
			;char    TabZaehlerTagE;         	// Tabellen-Zeiger fuer Tag E (Kerze)
			;char    TabZaehlerTagF;         	// Tabellen-Zeiger fuer Tag F (Kerze)
			;char    TabZaehlerTagG;         	// Tabellen-Zeiger fuer Tag G (Kerze)
			;char    TabZaehlerTagH;         	// Tabellen-Zeiger fuer Tag H (Kerze)
			;char    TabZaehlerTagI;         	// Tabellen-Zeiger fuer Tag I (Kerze)
			;char    TabZaehlerTagJ;         	// Tabellen-Zeiger fuer Tag J (Kerze)
			;char    TabZaehlerTagK;         	// Tabellen-Zeiger fuer Tag K (Kerze)
			;char    TabZaehlerTagL;         	// Tabellen-Zeiger fuer Tag L (Kerze)
			;char    TabZaehlerTagM;         	// Tabellen-Zeiger fuer Tag M (Kerze)
			;char    TabZaehlerTagN;         	// Tabellen-Zeiger fuer Tag N (Kerze)
			;char    TabZaehlerTagO;         	// Tabellen-Zeiger fuer Tag O (Kerze)
			;char    TabZaehlerTagP;         	// Tabellen-Zeiger fuer Tag P (Kerze)
			;char    TabZaehlerTagQ;         	// Tabellen-Zeiger fuer Tag Q (Kerze)
			;char    TabZaehlerTagR;         	// Tabellen-Zeiger fuer Tag R (Kerze)
			;char    TabZaehlerTagS;         	// Tabellen-Zeiger fuer Tag S (Kerze)
			;char    TabZaehlerTagT;         	// Tabellen-Zeiger fuer Tag T (Kerze)
			;char    TabZaehlerTagU;         	// Tabellen-Zeiger fuer Tag U (Kerze)
			;char    TabZaehlerTagV;         	// Tabellen-Zeiger fuer Tag V (Kerze)
			;char    TabZaehlerTagW;         	// Tabellen-Zeiger fuer Tag W (Kerze)
			;char    TabZaehlerTagX;         	// Tabellen-Zeiger fuer Tag X (Kerze)
			;char    TabZaehlerTagY;         	// Tabellen-Zeiger fuer Tag Y (Kerze)
			; 
			;#pragma rambank 2
			;char    PWM_LED_TagB;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagC;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagD;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagE;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagF;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagG;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagH;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagI;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagJ;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagK;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagL;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagM;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagN;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagO;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagP;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagQ;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagR;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagS;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagT;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagU;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagV;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagW;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagX;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;char    PWM_LED_TagY;           	// beinhaltet den Tabellenwert (PWM; Kerze)
			;
			; 
			;/****************** Unterprogramme und Funktionen **************************************/
			;
			;/***************************************************************************************/
			;/* Init_Flackerlicht_Kerzen:                                                           */
			;/*                                                                                     */
			;/* Aufgaben:                                                                           */
			;/*   + Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren                 */
			;/*   + Register fuer die Puls-Weiten-Modulation (PWM) initialisieren                   */
			;/*                                                                                     */
			;/* Uebergabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Rueckgabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/***************************************************************************************/
			;void Init_Flackerlicht_Kerzen(void)
			;{

PROG2   CODE
_const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF _LcAA+0
	MOVLW HIGH(cwdata1)
	MOVWF EEADRH
	RRF   _LcAA+0,W
	ANDLW .127
	ADDLW LOW(cwdata1)
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m001
	INCF  EEADRH,1
m001	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BTFSC _LcAA+0,0
	GOTO  m002
	MOVF  EEDATA,W
	ANDLW .127
	RETURN
m002	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
cwdata1
	DW    0xA11
	DW    0xB16
	DW    0xC99
	DW    0xF9B
	DW    0xB9E
	DW    0x913
	DW    0x893
	DW    0x78F
	DW    0x40A
	DW    0x204
	DW    0xA0A
	DW    0xC97
	DW    0xC99
	DW    0xA97
	DW    0xC14
	DW    0x991
	DW    0xE99
	DW    0xD9F
	DW    0xE96
	DW    0xE9D
	DW    0xF9F
	DW    0xA9B
	DW    0x510
	DW    0x285
	DW    0x386
	DW    0x508
	DW    0x78A
	DW    0x78F
	DW    0x812
	DW    0x98F
	DW    0xA93
	DW    0xB97
	DW    0xB96
	DW    0xB95
	DW    0x995
	DW    0x891
	DW    0x78F
	DW    0x78E
	DW    0x78F
	DW    0x891
	DW    0xB97
	DW    0xB97
	DW    0xA95
	DW    0xB97
	DW    0x897
	DW    0x811
	DW    0x912
	DW    0x691
	DW    0x791
	DW    0xA95
	DW    0xC99
	DW    0xA1C
	DW    0x894
	DW    0x710
	DW    0x40A
	DW    0x405
	DW    0x38A
	DW    0x287
	DW    0x404
	DW    0x404
	DW    0x58A
	DW    0x90F
	DW    0xB16
	DW    0xE16
	DW    0xF9C
	DW    0xE1F
	DW    0xE99
	DW    0xD9F
	DW    0xE96
	DW    0xE9D
	DW    0xF9F
	DW    0xA9B
	DW    0x510
	DW    0x285
	DW    0x386
	DW    0x508
	DW    0x50A
	DW    0x78C
	DW    0x306
	DW    0x4
	DW    0x0
	DW    0x505
	DW    0x80A
	DW    0xC99
	DW    0xA1C
	DW    0xE14
	DW    0xF9C
	DW    0xF9F
	DW    0xA1B
	DW    0x48A
	DW    0x306
	DW    0x306
	DW    0x50A
	DW    0x78F
	DW    0x50F
	DW    0x28A
	DW    0x285
	DW    0x50A
	DW    0x914
	DW    0xA14
	DW    0xC99
	DW    0x913
	DW    0x514
	DW    0x306
	DW    0x80
	DW    0x504
	DW    0x78A
	DW    0xA0F
	DW    0xA14
	DW    0xB96
	DW    0xE18
	DW    0x816
	DW    0x40E
	DW    0x0
	DW    0x50A
	DW    0xF14
	DW    0xF1F
	DW    0xD1C
	DW    0xF1E
	DW    0xE1C
	DW    0xC99
	DW    0xE1C
	DW    0xF9F
	DW    0xC99
	DW    0xF1E
	DW    0xF9F
	DW    0xE9D
	DW    0xB1B
Init_Flackerlicht_Kerzen
	GLOBAL Init_Flackerlicht_Kerzen
			;    // Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren
			;    TabZaehlerTagB = KONST_TABSTART_TAGB;
	MOVLW .25
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVWF TabZaehlerTagB
			;    TabZaehlerTagC = KONST_TABSTART_TAGC;
	MOVLW .75
	MOVWF TabZaehlerTagC
			;    TabZaehlerTagD = KONST_TABSTART_TAGD;
	MOVLW .125
	MOVWF TabZaehlerTagD
			;    TabZaehlerTagE = KONST_TABSTART_TAGE;
	MOVLW .175
	MOVWF TabZaehlerTagE
			;    TabZaehlerTagF = KONST_TABSTART_TAGF;
	MOVLW .10
	MOVWF TabZaehlerTagF
			;    TabZaehlerTagG = KONST_TABSTART_TAGG;
	MOVLW .60
	MOVWF TabZaehlerTagG
			;    TabZaehlerTagH = KONST_TABSTART_TAGH;
	MOVLW .110
	MOVWF TabZaehlerTagH
			;    TabZaehlerTagI = KONST_TABSTART_TAGI;
	MOVLW .160
	MOVWF TabZaehlerTagI
			;    TabZaehlerTagJ = KONST_TABSTART_TAGJ;
	MOVLW .210
	MOVWF TabZaehlerTagJ
			;    TabZaehlerTagK = KONST_TABSTART_TAGK;
	MOVLW .20
	MOVWF TabZaehlerTagK
			;    TabZaehlerTagL = KONST_TABSTART_TAGL;
	MOVLW .70
	MOVWF TabZaehlerTagL
			;    TabZaehlerTagM = KONST_TABSTART_TAGM;
	MOVLW .120
	MOVWF TabZaehlerTagM
			;    TabZaehlerTagN = KONST_TABSTART_TAGN;
	MOVLW .170
	MOVWF TabZaehlerTagN
			;    TabZaehlerTagO = KONST_TABSTART_TAGO;
	MOVLW .220
	MOVWF TabZaehlerTagO
			;    TabZaehlerTagP = KONST_TABSTART_TAGP;
	MOVLW .30
	MOVWF TabZaehlerTagP
			;    TabZaehlerTagQ = KONST_TABSTART_TAGQ;
	MOVLW .80
	MOVWF TabZaehlerTagQ
			;    TabZaehlerTagR = KONST_TABSTART_TAGR;
	MOVLW .130
	MOVWF TabZaehlerTagR
			;    TabZaehlerTagS = KONST_TABSTART_TAGS;
	MOVLW .180
	MOVWF TabZaehlerTagS
			;    TabZaehlerTagT = KONST_TABSTART_TAGT;
	MOVLW .230
	MOVWF TabZaehlerTagT
			;    TabZaehlerTagU = KONST_TABSTART_TAGU;
	MOVLW .40
	MOVWF TabZaehlerTagU
			;    TabZaehlerTagV = KONST_TABSTART_TAGV;
	MOVLW .90
	MOVWF TabZaehlerTagV
			;    TabZaehlerTagW = KONST_TABSTART_TAGW;
	MOVLW .140
	MOVWF TabZaehlerTagW
			;    TabZaehlerTagX = KONST_TABSTART_TAGX;
	MOVLW .190
	MOVWF TabZaehlerTagX
			;    TabZaehlerTagY = KONST_TABSTART_TAGY;
	MOVLW .240
	MOVWF TabZaehlerTagY
			;    
			;    
			;    // Register fuer die Puls-Weiten-Modulation (PWM) initialisieren
			;    PWM_Zaehler_Kerzen = 0;
	CLRF  PWM_Zaehler_Kerzen
			;    Gleichheitszaehler_Kerzen = KONST_GLEICHHEIT;
	MOVLW .5
	MOVWF Gleichheitszaehler_Kerzen
			;}
	RETURN
			;
			;
			;/***************************************************************************************/
			;/* Flackerlicht_Kerzen:                                                                */
			;/*                                                                                     */
			;/* Aufruf:                                                                             */
			;/*   alle 409 us (vom Hauptprogramm)                                                   */
			;/*                                                                                     */
			;/* Aufgabe:                                                                            */
			;/*   PWM fuer die Flackerlichter (Kerzen) erzeugen, und die Leuchtdioden (Bits         */
			;/*   TAGx_FLAMME und TAGxWACHS) setzen oder ruecksetzen.                               */          
			;/*                                                                                     */
			;/* Vorgehensweise:                                                                     */
			;/*   + PWM_Zaehler_Kerzen = 0: Je nachdem ob die Kerze "aktiv" ist                     */
			;/*     (TagesZaehler >= KONST_TAGx) diese Kerze (Flamme und Wachs) setzen oder rueck-  */
			;/*     setzen, und den naechsten Wert aus der Tabelle TabFlackerlicht lesen.           */
			;/*   + PWM_Zaehler_Kerzen == PWM_LED_Tagx: Die Leuchtdiode (Flamme der Kerze, Bit      */
			;/*     TAGx_FLAMME) ruecksetzen                                                        */
			;/*   + TabZaehlerTagx gibt an, welcher PWM-Wert aus der Tabelle (TabFlackerlicht)      */
			;/*     ausgegeben werden soll.                                                         */
			;/*                                                                                     */
			;/* Uebergabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Rueckgabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Anmerkung:                                                                          */
			;/*  + Zykluswiederholzeit des "Flackerns" bei einer Tabelle mit 256 Werten:            */
			;/*                                                                                     */
			;/*           4                                                                         */
			;/*    T = -------- * 256 * 8 * 32 * 5 * 256 = 16777216 us = ca. 17 Sekunden            */
			;/*        20 [MHz]                                                                     */
			;/*         |         |    |    |   |    |                                              */
			;/*         |         |    |    |   |    +-- Anz. der Tabellenwerte (hier 256)          */
			;/*         |         |    |    |   +------- Anz. der gleichen PWM (hier 5)             */
			;/*         |         |    |    +----------- max. PWM-Zyklen -> 61 Hz                   */
			;/*         |         |    +---------------- Vorteiler fuer Timer 0 (hier 8)            */
			;/*         |         +--------------------- Timer-0-Ueberlauf                          */
			;/*         +------------------------------- Takt                                       */
			;/***************************************************************************************/
			;void Flackerlicht_Kerzen(void)
			;{
Flackerlicht_Kerzen
	GLOBAL Flackerlicht_Kerzen
			;    if (PWM_Zaehler_Kerzen == 0)
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,1
	BTFSS 0x03,Zero_
	GOTO  m052
			;    {
			;        if (TagesZaehler >= KONST_TAGB)
	MOVLW .6
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m003
			;        {
			;            TAGB_FLAMME = 1;
	BSF   Flackerlichter0+0,4
			;            TAGB_WACHS = 1;
	BSF   Flackerlichter0+0,3
			;        }
			;        else
	GOTO  m004
			;        {
			;            TAGB_FLAMME = 0;
m003	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter0+0,4
			;            TAGB_WACHS = 0;
	BCF   Flackerlichter0+0,3
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGC)
m004	MOVLW .3
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m005
			;        {
			;            TAGC_FLAMME = 1;
	BSF   Flackerlichter0+0,6
			;            TAGC_WACHS = 1;
	BSF   Flackerlichter0+0,5
			;        }
			;        else
	GOTO  m006
			;        {
			;            TAGC_FLAMME = 0;
m005	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter0+0,6
			;            TAGC_WACHS = 0;
	BCF   Flackerlichter0+0,5
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGD)
m006	MOVLW .24
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m007
			;        {
			;            TAGD_FLAMME = 1;
	BSF   Flackerlichter10+0,3
			;            TAGD_WACHS = 1;
	BSF   Flackerlichter10+0,4
			;        }
			;        else
	GOTO  m008
			;        {
			;            TAGD_FLAMME = 0;
m007	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,3
			;            TAGD_WACHS = 0;
	BCF   Flackerlichter10+0,4
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGE)
m008	MOVLW .10
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m009
			;        {
			;            TAGE_FLAMME = 1;
	BSF   Flackerlichter10+0,5
			;            TAGE_WACHS = 1;
	BSF   Flackerlichter12+0,0
			;        }
			;        else
	GOTO  m010
			;        {
			;            TAGE_FLAMME = 0;
m009	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,5
			;            TAGE_WACHS = 0;
	BCF   Flackerlichter12+0,0
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGF)
m010	MOVLW .20
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m011
			;        {
			;            TAGF_FLAMME = 1;
	BSF   Flackerlichter11+0,4
			;            TAGF_WACHS = 1;
	BSF   Flackerlichter11+0,6
			;        }
			;        else
	GOTO  m012
			;        {
			;            TAGF_FLAMME = 0;
m011	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter11+0,4
			;            TAGF_WACHS = 0;
	BCF   Flackerlichter11+0,6
			;        }
			;        
			;        if (TagesZaehler >= KONST_TAGG)
m012	MOVLW .14
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m013
			;        {
			;            TAGG_FLAMME = 1;
	BSF   Flackerlichter11+0,3
			;            TAGG_WACHS = 1;
	BSF   Flackerlichter11+0,5
			;        }
			;        else
	GOTO  m014
			;        {
			;            TAGG_FLAMME = 0;
m013	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter11+0,3
			;            TAGG_WACHS = 0;
	BCF   Flackerlichter11+0,5
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGH)
m014	MOVLW .5
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m015
			;        {
			;            TAGH_FLAMME = 1;
	BSF   Flackerlichter10+0,6
			;            TAGH_WACHS = 1;
	BSF   Flackerlichter11+0,2
			;        }
			;        else
	GOTO  m016
			;        {
			;            TAGH_FLAMME = 0;
m015	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,6
			;            TAGH_WACHS = 0;
	BCF   Flackerlichter11+0,2
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGI)
m016	MOVLW .7
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m017
			;        {
			;            TAGI_FLAMME = 1;
	BSF   Flackerlichter1+0,3
			;            TAGI_WACHS = 1;
	BSF   Flackerlichter1+0,6
			;        }
			;        else
	GOTO  m018
			;        {
			;            TAGI_FLAMME = 0;
m017	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter1+0,3
			;            TAGI_WACHS = 0;
	BCF   Flackerlichter1+0,6
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGJ)
m018	MOVLW .18
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m019
			;        {
			;            TAGJ_FLAMME = 1;
	BSF   Flackerlichter1+0,5
			;            TAGJ_WACHS = 1;
	BSF   Flackerlichter1+0,2
			;        }
			;        else
	GOTO  m020
			;        {
			;            TAGJ_FLAMME = 0;
m019	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter1+0,5
			;            TAGJ_WACHS = 0;
	BCF   Flackerlichter1+0,2
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGK)
m020	MOVLW .11
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m021
			;        {
			;            TAGK_FLAMME = 1;
	BSF   Flackerlichter2+0,1
			;            TAGK_WACHS = 1;
	BSF   Flackerlichter2+0,0
			;        }
			;        else
	GOTO  m022
			;        {
			;            TAGK_FLAMME = 0;
m021	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter2+0,1
			;            TAGK_WACHS = 0;
	BCF   Flackerlichter2+0,0
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGL)
m022	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TagesZaehler,1
	BTFSC 0x03,Zero_
	GOTO  m023
			;        {
			;            TAGL_FLAMME = 1;
	BSF   Flackerlichter9+0,0
			;            TAGL_WACHS = 1;
	BSF   Flackerlichter9+0,1
			;        }
			;        else
	GOTO  m024
			;        {
			;            TAGL_FLAMME = 0;
m023	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,0
			;            TAGL_WACHS = 0;
	BCF   Flackerlichter9+0,1
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGM)
m024	MOVLW .15
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m025
			;        {
			;            TAGM_FLAMME = 1;
	BSF   Flackerlichter9+0,3
			;            TAGM_WACHS = 1;
	BSF   Flackerlichter9+0,4
			;        }
			;        else
	GOTO  m026
			;        {
			;            TAGM_FLAMME = 0;
m025	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,3
			;            TAGM_WACHS = 0;
	BCF   Flackerlichter9+0,4
			;        }
			;
			;
			;        if (TagesZaehler >= KONST_TAGN)
m026	MOVLW .23
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m027
			;        {
			;            TAGN_FLAMME = 1;
	BSF   Flackerlichter9+0,6
			;            TAGN_WACHS = 1;
	BSF   Flackerlichter10+0,1
			;        }
			;        else
	GOTO  m028
			;        {
			;            TAGN_FLAMME = 0;
m027	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,6
			;            TAGN_WACHS = 0;
	BCF   Flackerlichter10+0,1
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGO)
m028	MOVLW .16
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m029
			;        {
			;            TAGO_FLAMME = 1;
	BSF   Flackerlichter2+0,4
			;            TAGO_WACHS = 1;
	BSF   Flackerlichter2+0,3
			;        }
			;        else
	GOTO  m030
			;        {
			;            TAGO_FLAMME = 0;
m029	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter2+0,4
			;            TAGO_WACHS = 0;
	BCF   Flackerlichter2+0,3
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGP)
m030	MOVLW .12
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m031
			;        {
			;            TAGP_FLAMME = 1;
	BSF   Flackerlichter3+0,0
			;            TAGP_WACHS = 1;
	BSF   Flackerlichter2+0,5
			;        }
			;        else
	GOTO  m032
			;        {
			;            TAGP_FLAMME = 0;
m031	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,0
			;            TAGP_WACHS = 0;
	BCF   Flackerlichter2+0,5
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGQ)
m032	MOVLW .22
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m033
			;        {
			;            TAGQ_FLAMME = 1;
	BSF   Flackerlichter8+0,1
			;            TAGQ_WACHS = 1;
	BSF   Flackerlichter8+0,2
			;        }
			;        else
	GOTO  m034
			;        {
			;            TAGQ_FLAMME = 0;
m033	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,1
			;            TAGQ_WACHS = 0;
	BCF   Flackerlichter8+0,2
			;        }
			;        
			;        if (TagesZaehler >= KONST_TAGR)
m034	MOVLW .8
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m035
			;        {
			;            TAGR_FLAMME = 1;
	BSF   Flackerlichter8+0,4
			;            TAGR_WACHS = 1;
	BSF   Flackerlichter8+0,5
			;        }
			;        else
	GOTO  m036
			;        {
			;            TAGR_FLAMME = 0;
m035	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,4
			;            TAGR_WACHS = 0;
	BCF   Flackerlichter8+0,5
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGS)
m036	MOVLW .4
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m037
			;        {
			;            TAGS_FLAMME = 1;
	BSF   Flackerlichter8+0,6
			;            TAGS_WACHS = 1;
	BSF   Flackerlichter8+0,0
			;        }
			;        else
	GOTO  m038
			;        {
			;            TAGS_FLAMME = 0;
m037	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,6
			;            TAGS_WACHS = 0;
	BCF   Flackerlichter8+0,0
			;        }
			;        
			;        if (TagesZaehler >= KONST_TAGT)
m038	MOVLW .19
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m039
			;        {
			;            TAGT_FLAMME = 1;
	BSF   Flackerlichter3+0,2
			;            TAGT_WACHS = 1;
	BSF   Flackerlichter3+0,3
			;        }
			;        else
	GOTO  m040
			;        {
			;            TAGT_FLAMME = 0;
m039	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,2
			;            TAGT_WACHS = 0;
	BCF   Flackerlichter3+0,3
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGU)
m040	MOVLW .2
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m041
			;        {
			;            TAGU_FLAMME = 1;
	BSF   Flackerlichter3+0,4
			;            TAGU_WACHS = 1;
	BSF   Flackerlichter3+0,5
			;        }
			;        else
	GOTO  m042
			;        {
			;            TAGU_FLAMME = 0;
m041	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,4
			;            TAGU_WACHS = 0;
	BCF   Flackerlichter3+0,5
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGV)
m042	MOVLW .13
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m043
			;        {
			;            TAGV_FLAMME = 1;
	BSF   Flackerlichter7+0,2
			;            TAGV_WACHS = 1;
	BSF   Flackerlichter7+0,4
			;        }
			;        else
	GOTO  m044
			;        {
			;            TAGV_FLAMME = 0;
m043	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter7+0,2
			;            TAGV_WACHS = 0;
	BCF   Flackerlichter7+0,4
			;        }
			;
			;        if (TagesZaehler >= KONST_TAGW)
m044	MOVLW .21
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m045
			;        {
			;            TAGW_FLAMME = 1;
	BSF   Flackerlichter7+0,5
			;            TAGW_WACHS = 1;
	BSF   Flackerlichter7+0,6
			;        }
			;        else
	GOTO  m046
			;        {
			;            TAGW_FLAMME = 0;
m045	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter7+0,5
			;            TAGW_WACHS = 0;
	BCF   Flackerlichter7+0,6
			;        }       
			;
			;        if (TagesZaehler >= KONST_TAGX)
m046	MOVLW .17
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m047
			;        {
			;            TAGX_FLAMME = 1;
	BSF   Flackerlichter5+0,2
			;            TAGX_WACHS = 1;
	BSF   Flackerlichter5+0,4
			;        }
			;        else
	GOTO  m048
			;        {
			;            TAGX_FLAMME = 0;
m047	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter5+0,2
			;            TAGX_WACHS = 0;
	BCF   Flackerlichter5+0,4
			;        }       
			;
			;        if (TagesZaehler >= KONST_TAGY)
m048	MOVLW .9
	BSF   0x03,RP0
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m049
			;        {
			;            TAGY_FLAMME = 1;
	BSF   Flackerlichter5+0,6
			;            TAGY_WACHS = 1;
	BSF   Flackerlichter5+0,5
			;        }
			;        else
	GOTO  m050
			;        {
			;            TAGY_FLAMME = 0;
m049	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter5+0,6
			;            TAGY_WACHS = 0;
	BCF   Flackerlichter5+0,5
			;        }       
			; 
			;        Gleichheitszaehler_Kerzen--;
m050	BSF   0x03,RP0
	BCF   0x03,RP1
	DECF  Gleichheitszaehler_Kerzen,1
			;        if (Gleichheitszaehler_Kerzen == 0)
	MOVF  Gleichheitszaehler_Kerzen,1
	BTFSS 0x03,Zero_
	GOTO  m051
			;        {
			;            Gleichheitszaehler_Kerzen = KONST_GLEICHHEIT;
	MOVLW .5
	MOVWF Gleichheitszaehler_Kerzen
			;
			;            TabZaehlerTagB++;
	INCF  TabZaehlerTagB,1
			;            PWM_LED_TagB = TabFlackerlicht[TabZaehlerTagB];
	MOVF  TabZaehlerTagB,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagB
			;
			;            TabZaehlerTagC++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagC,1
			;            PWM_LED_TagC = TabFlackerlicht[TabZaehlerTagC];
	MOVF  TabZaehlerTagC,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagC
			;
			;            TabZaehlerTagD++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagD,1
			;            PWM_LED_TagD = TabFlackerlicht[TabZaehlerTagD];
	MOVF  TabZaehlerTagD,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagD
			;
			;            TabZaehlerTagE++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagE,1
			;            PWM_LED_TagE = TabFlackerlicht[TabZaehlerTagE];
	MOVF  TabZaehlerTagE,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagE
			;
			;            TabZaehlerTagF++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagF,1
			;            PWM_LED_TagF = TabFlackerlicht[TabZaehlerTagF];
	MOVF  TabZaehlerTagF,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagF
			;
			;            TabZaehlerTagG++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagG,1
			;            PWM_LED_TagG = TabFlackerlicht[TabZaehlerTagG];
	MOVF  TabZaehlerTagG,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagG
			;
			;            TabZaehlerTagH++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagH,1
			;            PWM_LED_TagH = TabFlackerlicht[TabZaehlerTagH];
	MOVF  TabZaehlerTagH,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagH
			;
			;            TabZaehlerTagI++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagI,1
			;            PWM_LED_TagI = TabFlackerlicht[TabZaehlerTagI];
	MOVF  TabZaehlerTagI,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagI
			;
			;            TabZaehlerTagJ++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagJ,1
			;            PWM_LED_TagJ = TabFlackerlicht[TabZaehlerTagJ];
	MOVF  TabZaehlerTagJ,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagJ
			;
			;            TabZaehlerTagK++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagK,1
			;            PWM_LED_TagK = TabFlackerlicht[TabZaehlerTagK];
	MOVF  TabZaehlerTagK,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagK
			;
			;            TabZaehlerTagL++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagL,1
			;            PWM_LED_TagL = TabFlackerlicht[TabZaehlerTagL];
	MOVF  TabZaehlerTagL,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagL
			;
			;            TabZaehlerTagM++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagM,1
			;            PWM_LED_TagM = TabFlackerlicht[TabZaehlerTagM];
	MOVF  TabZaehlerTagM,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagM
			;
			;            TabZaehlerTagN++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagN,1
			;            PWM_LED_TagN = TabFlackerlicht[TabZaehlerTagN];
	MOVF  TabZaehlerTagN,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagN
			;
			;            TabZaehlerTagO++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagO,1
			;            PWM_LED_TagO = TabFlackerlicht[TabZaehlerTagO];
	MOVF  TabZaehlerTagO,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagO
			;
			;            TabZaehlerTagP++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagP,1
			;            PWM_LED_TagP = TabFlackerlicht[TabZaehlerTagP];
	MOVF  TabZaehlerTagP,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagP
			;
			;            TabZaehlerTagQ++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagQ,1
			;            PWM_LED_TagQ = TabFlackerlicht[TabZaehlerTagQ];
	MOVF  TabZaehlerTagQ,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagQ
			;
			;            TabZaehlerTagR++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagR,1
			;            PWM_LED_TagR = TabFlackerlicht[TabZaehlerTagR];
	MOVF  TabZaehlerTagR,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagR
			;
			;            TabZaehlerTagS++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagS,1
			;            PWM_LED_TagS = TabFlackerlicht[TabZaehlerTagS];
	MOVF  TabZaehlerTagS,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagS
			;
			;            TabZaehlerTagT++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagT,1
			;            PWM_LED_TagT = TabFlackerlicht[TabZaehlerTagT];
	MOVF  TabZaehlerTagT,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagT
			;
			;            TabZaehlerTagU++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagU,1
			;            PWM_LED_TagU = TabFlackerlicht[TabZaehlerTagU];
	MOVF  TabZaehlerTagU,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagU
			;
			;            TabZaehlerTagV++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagV,1
			;            PWM_LED_TagV = TabFlackerlicht[TabZaehlerTagV];
	MOVF  TabZaehlerTagV,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagV
			;
			;            TabZaehlerTagW++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagW,1
			;            PWM_LED_TagW = TabFlackerlicht[TabZaehlerTagW];
	MOVF  TabZaehlerTagW,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagW
			;
			;            TabZaehlerTagX++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagX,1
			;            PWM_LED_TagX = TabFlackerlicht[TabZaehlerTagX];
	MOVF  TabZaehlerTagX,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagX
			;
			;            TabZaehlerTagY++;
	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  TabZaehlerTagY,1
			;            PWM_LED_TagY = TabFlackerlicht[TabZaehlerTagY];
	MOVF  TabZaehlerTagY,W
	CALL  _const1
	BCF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagY
			;         }
			;    }
			;    else
m051	GOTO  m076
			;    {
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagB) TAGB_FLAMME = 0;
m052	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagB,W
	BTFSS 0x03,Zero_
	GOTO  m053
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter0+0,4
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagC) TAGC_FLAMME = 0;
m053	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagC,W
	BTFSS 0x03,Zero_
	GOTO  m054
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter0+0,6
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagD) TAGD_FLAMME = 0;
m054	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagD,W
	BTFSS 0x03,Zero_
	GOTO  m055
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,3
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagE) TAGE_FLAMME = 0;
m055	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagE,W
	BTFSS 0x03,Zero_
	GOTO  m056
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,5
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagF) TAGF_FLAMME = 0;
m056	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagF,W
	BTFSS 0x03,Zero_
	GOTO  m057
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter11+0,4
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagG) TAGG_FLAMME = 0;
m057	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagG,W
	BTFSS 0x03,Zero_
	GOTO  m058
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter11+0,3
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagH) TAGH_FLAMME = 0;
m058	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagH,W
	BTFSS 0x03,Zero_
	GOTO  m059
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter10+0,6
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagI) TAGI_FLAMME = 0;
m059	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagI,W
	BTFSS 0x03,Zero_
	GOTO  m060
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter1+0,3
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagJ) TAGJ_FLAMME = 0;
m060	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagJ,W
	BTFSS 0x03,Zero_
	GOTO  m061
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter1+0,5
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagK) TAGK_FLAMME = 0;
m061	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagK,W
	BTFSS 0x03,Zero_
	GOTO  m062
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter2+0,1
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagL) TAGL_FLAMME = 0;
m062	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagL,W
	BTFSS 0x03,Zero_
	GOTO  m063
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,0
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagM) TAGM_FLAMME = 0;
m063	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagM,W
	BTFSS 0x03,Zero_
	GOTO  m064
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,3
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagN) TAGN_FLAMME = 0;
m064	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagN,W
	BTFSS 0x03,Zero_
	GOTO  m065
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter9+0,6
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagO) TAGO_FLAMME = 0;
m065	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagO,W
	BTFSS 0x03,Zero_
	GOTO  m066
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter2+0,4
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagP) TAGP_FLAMME = 0;
m066	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagP,W
	BTFSS 0x03,Zero_
	GOTO  m067
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,0
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagQ) TAGQ_FLAMME = 0;
m067	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagQ,W
	BTFSS 0x03,Zero_
	GOTO  m068
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,1
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagR) TAGR_FLAMME = 0;
m068	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagR,W
	BTFSS 0x03,Zero_
	GOTO  m069
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,4
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagS) TAGS_FLAMME = 0;
m069	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagS,W
	BTFSS 0x03,Zero_
	GOTO  m070
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter8+0,6
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagT) TAGT_FLAMME = 0;
m070	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagT,W
	BTFSS 0x03,Zero_
	GOTO  m071
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,2
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagU) TAGU_FLAMME = 0;
m071	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagU,W
	BTFSS 0x03,Zero_
	GOTO  m072
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter3+0,4
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagV) TAGV_FLAMME = 0;
m072	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagV,W
	BTFSS 0x03,Zero_
	GOTO  m073
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter7+0,2
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagW) TAGW_FLAMME = 0;
m073	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagW,W
	BTFSS 0x03,Zero_
	GOTO  m074
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter7+0,5
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagX) TAGX_FLAMME = 0;
m074	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagX,W
	BTFSS 0x03,Zero_
	GOTO  m075
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter5+0,2
			;        if (PWM_Zaehler_Kerzen == PWM_LED_TagY) TAGY_FLAMME = 0;
m075	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  PWM_Zaehler_Kerzen,W
	BCF   0x03,RP0
	BSF   0x03,RP1
	XORWF PWM_LED_TagY,W
	BTFSS 0x03,Zero_
	GOTO  m076
	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter5+0,6
			;    }
			;
			;    PWM_Zaehler_Kerzen++;
m076	BSF   0x03,RP0
	BCF   0x03,RP1
	INCF  PWM_Zaehler_Kerzen,1
			;    if (PWM_Zaehler_Kerzen == KONST_PWM_OBERGRENZE) 
	MOVF  PWM_Zaehler_Kerzen,W
	XORLW .32
	BTFSS 0x03,Zero_
	GOTO  m077
			;    {
			;        PWM_Zaehler_Kerzen = 0;
	CLRF  PWM_Zaehler_Kerzen
			;    }
			;}
m077	RETURN

	END


; *** KEY INFO ***

; 0x08D3 P1  786 word(s) 38 % : Flackerlicht_Kerzen
; 0x089D P1   54 word(s)  2 % : Init_Flackerlicht_Kerzen
; 0x0800 P1  157 word(s)  7 % : _const1

; RAM usage: 65 bytes (1 local), 303 bytes free
; Maximum call level: 1
;  Codepage 0 has    1 word(s) :   0 %
;  Codepage 1 has  997 word(s) :  48 %
; Total of 998 code words (24 %)
