
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  15. Dec 2009  15:39  *************

	processor  16F87
	radix  DEC

Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
  EXTERN Flackerlichter4
  EXTERN Flackerlichter5
  EXTERN Flackerlichter6
  EXTERN TagesZaehler
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
RD          EQU   0
EEPGD       EQU   7

BANK3    UDATA
PWM_Zaehler_Stern RES   1
  GLOBAL PWM_Zaehler_Stern
Gleichheitszaehler_Stern RES   1
  GLOBAL Gleichheitszaehler_Stern
TabZaehlerTagZ1 RES   1
  GLOBAL TabZaehlerTagZ1
TabZaehlerTagZ2 RES   1
  GLOBAL TabZaehlerTagZ2
TabZaehlerTagZ3 RES   1
  GLOBAL TabZaehlerTagZ3
TabZaehlerTagZ4 RES   1
  GLOBAL TabZaehlerTagZ4
TabZaehlerTagZ5 RES   1
  GLOBAL TabZaehlerTagZ5
TabZaehlerTagZ6 RES   1
  GLOBAL TabZaehlerTagZ6
TabZaehlerTagZ7 RES   1
  GLOBAL TabZaehlerTagZ7
TabZaehlerTagZ8 RES   1
  GLOBAL TabZaehlerTagZ8
TabZaehlerTagZ9 RES   1
  GLOBAL TabZaehlerTagZ9
TabZaehlerTagZ10 RES   1
  GLOBAL TabZaehlerTagZ10
TabZaehlerTagZ11 RES   1
  GLOBAL TabZaehlerTagZ11
TabZaehlerTagZ12 RES   1
  GLOBAL TabZaehlerTagZ12
PWM_LED_TagZ1 RES   1
  GLOBAL PWM_LED_TagZ1
PWM_LED_TagZ2 RES   1
  GLOBAL PWM_LED_TagZ2
PWM_LED_TagZ3 RES   1
  GLOBAL PWM_LED_TagZ3
PWM_LED_TagZ4 RES   1
  GLOBAL PWM_LED_TagZ4
PWM_LED_TagZ5 RES   1
  GLOBAL PWM_LED_TagZ5
PWM_LED_TagZ6 RES   1
  GLOBAL PWM_LED_TagZ6
PWM_LED_TagZ7 RES   1
  GLOBAL PWM_LED_TagZ7
PWM_LED_TagZ8 RES   1
  GLOBAL PWM_LED_TagZ8
PWM_LED_TagZ9 RES   1
  GLOBAL PWM_LED_TagZ9
PWM_LED_TagZ10 RES   1
  GLOBAL PWM_LED_TagZ10
PWM_LED_TagZ11 RES   1
  GLOBAL PWM_LED_TagZ11
PWM_LED_TagZ12 RES   1
  GLOBAL PWM_LED_TagZ12
_LcYA       RES   1
  GLOBAL _LcYA

  ; FILE FLACKERLICHT_STERN.C
			;/***************************************************************************************/
			;/* Unterprogramme zur Erzeugung des Flackerlichts (fuer den Stern) mit Hilfe einer     */
			;/* Tabelle                                                                             */
			;/*                                                                                     */
			;/* Compiler: CC5X                                                                      */
			;/*                                                                                     */
			;/* Entwickler: Buchgeher Stefan                                                        */
			;/* Entwicklungsbeginn der Software: 27. September 2008                                 */
			;/* Funktionsfaehig seit: 27. September 2008                                            */
			;/* Letzte Bearbeitung: 21. Juni 2009                                                   */
			;/***************************************************************************************/
			;
			;/****************** Include-Dateien ****************************************************/
			;#include "PROJEKT.H"
			; 
			;
			;/****************** Globale Register ***************************************************/
			;#pragma rambank 3
			;
			;char    PWM_Zaehler_Stern;            	// Hilfszaehler zur Erzeugung der PWM
			;char    Gleichheitszaehler_Stern;     	// mehrere gleiche PWMs nacheinander
			;
			;char    TabZaehlerTagZ1;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ2;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ3;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ4;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ5;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ6;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ7;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ8;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ9;        	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ10;       	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ11;       	// Tabellen-Zeiger fuer Tag Z Stern)
			;char    TabZaehlerTagZ12;       	// Tabellen-Zeiger fuer Tag Z Stern)
			;
			;//#pragma rambank 2
			;char    PWM_LED_TagZ1;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ2;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ3;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ4;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ5;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ6;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ7;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ8;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ9;          	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ10;         	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ11;         	// beinhaltet den Tabellenwert (PWM; Stern)
			;char    PWM_LED_TagZ12;         	// beinhaltet den Tabellenwert (PWM; Stern)
			;
			;
			;/****************** Unterprogramme und Funktionen **************************************/
			;
			;/***************************************************************************************/
			;/* Init_Flackerlicht_Stern:                                                            */
			;/*                                                                                     */
			;/* Aufgaben:                                                                           */
			;/*   + Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren                 */
			;/*   + Register fuer die Puls-Weiten-Modulation (PWM) initialisieren                   */
			;/*                                                                                     */
			;/* Uebergabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Rueckgabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/***************************************************************************************/
			;void Init_Flackerlicht_Stern(void)
			;{

PROG2   CODE
_const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF _LcYA+0
	MOVLW HIGH(cwdata1)
	BCF   0x03,RP0
	MOVWF EEADRH
	BSF   0x03,RP0
	RRF   _LcYA+0,W
	ANDLW .127
	ADDLW LOW(cwdata1)
	BCF   0x03,RP0
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m001
	INCF  EEADRH,1
m001	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BTFSC _LcYA+0,0
	GOTO  m002
	BCF   0x03,RP0
	MOVF  EEDATA,W
	ANDLW .127
	RETURN
m002	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
cwdata1
	DW    0xA11
	DW    0xB16
	DW    0xC99
	DW    0xF9B
	DW    0xB9E
	DW    0x913
	DW    0x893
	DW    0x78F
	DW    0x40A
	DW    0x204
	DW    0xA0A
	DW    0xC97
	DW    0xC99
	DW    0xA97
	DW    0xC14
	DW    0x991
	DW    0xE99
	DW    0xD9F
	DW    0xE96
	DW    0xE9D
	DW    0xF9F
	DW    0xA9B
	DW    0x510
	DW    0x285
	DW    0x386
	DW    0x508
	DW    0x78A
	DW    0x78F
	DW    0x812
	DW    0x98F
	DW    0xA93
	DW    0xB97
	DW    0xB96
	DW    0xB95
	DW    0x995
	DW    0x891
	DW    0x78F
	DW    0x78E
	DW    0x78F
	DW    0x891
	DW    0xB97
	DW    0xB97
	DW    0xA95
	DW    0xB97
	DW    0x897
	DW    0x811
	DW    0x912
	DW    0x691
	DW    0x791
	DW    0xA95
	DW    0xC99
	DW    0xA1C
	DW    0x894
	DW    0x710
	DW    0x40A
	DW    0x405
	DW    0x38A
	DW    0x287
	DW    0x404
	DW    0x404
	DW    0x58A
	DW    0x90F
	DW    0xB16
	DW    0xE16
	DW    0xF9C
	DW    0xE1F
	DW    0xE99
	DW    0xD9F
	DW    0xE96
	DW    0xE9D
	DW    0xF9F
	DW    0xA9B
	DW    0x510
	DW    0x285
	DW    0x386
	DW    0x508
	DW    0x50A
	DW    0x78C
	DW    0x306
	DW    0x4
	DW    0x0
	DW    0x505
	DW    0x80A
	DW    0xC99
	DW    0xA1C
	DW    0xE14
	DW    0xF9C
	DW    0xF9F
	DW    0xA1B
	DW    0x48A
	DW    0x306
	DW    0x306
	DW    0x50A
	DW    0x78F
	DW    0x50F
	DW    0x28A
	DW    0x285
	DW    0x50A
	DW    0x914
	DW    0xA14
	DW    0xC99
	DW    0x913
	DW    0x514
	DW    0x306
	DW    0x80
	DW    0x504
	DW    0x78A
	DW    0xA0F
	DW    0xA14
	DW    0xB96
	DW    0xE18
	DW    0x816
	DW    0x40E
	DW    0x0
	DW    0x50A
	DW    0xF14
	DW    0xF1F
	DW    0xD1C
	DW    0xF1E
	DW    0xE1C
	DW    0xC99
	DW    0xE1C
	DW    0xF9F
	DW    0xC99
	DW    0xF1E
	DW    0xF9F
	DW    0xE9D
	DW    0xB1B
Init_Flackerlicht_Stern
	GLOBAL Init_Flackerlicht_Stern
			;    // Zaehlregister fuer die Flackerlichter (Tabellen) initialisieren
			;    TabZaehlerTagZ1 = KONST_TABSTART_TAGZ1;
	MOVLW .5
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF TabZaehlerTagZ1
			;    TabZaehlerTagZ2 = KONST_TABSTART_TAGZ2;
	MOVLW .35
	MOVWF TabZaehlerTagZ2
			;    TabZaehlerTagZ3 = KONST_TABSTART_TAGZ3;
	MOVLW .65
	MOVWF TabZaehlerTagZ3
			;    TabZaehlerTagZ4 = KONST_TABSTART_TAGZ4;
	MOVLW .95
	MOVWF TabZaehlerTagZ4
			;    TabZaehlerTagZ5 = KONST_TABSTART_TAGZ5;
	MOVLW .125
	MOVWF TabZaehlerTagZ5
			;    TabZaehlerTagZ6 = KONST_TABSTART_TAGZ6;
	MOVLW .155
	MOVWF TabZaehlerTagZ6
			;    TabZaehlerTagZ7 = KONST_TABSTART_TAGZ7;
	MOVLW .185
	MOVWF TabZaehlerTagZ7
			;    TabZaehlerTagZ8 = KONST_TABSTART_TAGZ8;
	MOVLW .215
	MOVWF TabZaehlerTagZ8
			;    TabZaehlerTagZ9 = KONST_TABSTART_TAGZ9;
	MOVLW .245
	MOVWF TabZaehlerTagZ9
			;    TabZaehlerTagZ10 = KONST_TABSTART_TAGZ10;
	MOVLW .55
	MOVWF TabZaehlerTagZ10
			;    TabZaehlerTagZ11 = KONST_TABSTART_TAGZ11;
	MOVLW .105
	MOVWF TabZaehlerTagZ11
			;    TabZaehlerTagZ12 = KONST_TABSTART_TAGZ12;
	MOVLW .155
	MOVWF TabZaehlerTagZ12
			;    
			;    // Register fuer die Puls-Weiten-Modulation (PWM) initialisieren
			;    PWM_Zaehler_Stern = 0;
	CLRF  PWM_Zaehler_Stern
			;    Gleichheitszaehler_Stern = KONST_GLEICHHEIT;
	MOVLW .5
	MOVWF Gleichheitszaehler_Stern
			;}
	RETURN
			;
			;
			;/***************************************************************************************/
			;/* Flackerlicht_Stern:                                                                 */
			;/*                                                                                     */
			;/* Aufruf:                                                                             */
			;/*   alle 409 us (vom Hauptprogramm)                                                   */
			;/*                                                                                     */
			;/* Aufgabe:                                                                            */
			;/*   PWM fuer die Flackerlichter (Stern) erzeugen, und die Leuchtdioden (Bits          */
			;/*   TAGZ_STERNx) setzen oder ruecksetzen.                                             */          
			;/*                                                                                     */
			;/* Vorgehensweise:                                                                     */
			;/*   + PWM_Zaehler_Stern = 0: Je nachdem ob der Stern "aktiv" ist                      */
			;/*     (TagesZaehler >= KONST_TAGZ) alle Leuchtdioden die den Stern symbolisieren      */
			;/*     aktivieren (setzen) und den naechsten Wert aus der Tabelle TabFlackerlicht      */
			;/*     lesen.                                                                          */
			;/*   + PWM_Zaehler_Stern = PWM_LED_TagZx: Die Leuchtdiode (Bit TAGZ_STERNx) rueck-     */
			;/*     setzen                                                                          */
			;/*   + TabZaehlerTagZx gibt an, welcher PWM-Wert aus der Tabelle (TabFlackerlicht)     */
			;/*     ausgegeben werden soll.                                                         */
			;/*                                                                                     */
			;/* Uebergabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Rueckgabeparameter:                                                                 */
			;/*   keiner                                                                            */
			;/*                                                                                     */
			;/* Anmerkung:                                                                          */
			;/*  + Zykluswiederholzeit des "Flackerns" bei einer Tabelle mit 256 Werten:            */
			;/*                                                                                     */
			;/*           4                                                                         */
			;/*    T = -------- * 256 * 8 * 32 * 5 * 256 = 16777216 us = ca. 17 Sekunden            */
			;/*        20 [MHz]                                                                     */
			;/*         |         |    |    |   |    |                                              */
			;/*         |         |    |    |   |    +-- Anz. der Tabellenwerte (hier 256)          */
			;/*         |         |    |    |   +------- Anz. der gleichen PWM (hier 5)             */
			;/*         |         |    |    +----------- max. PWM-Zyklen -> 61 Hz                   */
			;/*         |         |    +---------------- Vorteiler fuer Timer 0 (hier 8)            */
			;/*         |         +--------------------- Timer-0-Ueberlauf                          */
			;/*         +------------------------------- Takt                                       */
			;/***************************************************************************************/
			;void Flackerlicht_Stern(void)
			;{
Flackerlicht_Stern
	GLOBAL Flackerlicht_Stern
			;    if (PWM_Zaehler_Stern == 0)
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,1
	BTFSS 0x03,Zero_
	GOTO  m006
			;    {
			;        if (TagesZaehler >= KONST_TAGZ)
	MOVLW .24
	BCF   0x03,RP1
	SUBWF TagesZaehler,W
	BTFSS 0x03,Carry
	GOTO  m003
			;        {
			;            TAGZ_STERN1 = 1;
	BSF   Flackerlichter4+0,3
			;            TAGZ_STERN2 = 1;
	BSF   Flackerlichter4+0,4
			;            TAGZ_STERN3 = 1;
	BSF   Flackerlichter4+0,5
			;            TAGZ_STERN4 = 1;
	BSF   Flackerlichter4+0,6
			;            TAGZ_STERN5 = 1;
	BSF   Flackerlichter4+0,7
			;            TAGZ_STERN6 = 1;
	BSF   Flackerlichter5+0,0
			;            TAGZ_STERN7 = 1;
	BSF   Flackerlichter6+0,0
			;            TAGZ_STERN8 = 1;
	BSF   Flackerlichter6+0,1
			;            TAGZ_STERN9 = 1;
	BSF   Flackerlichter6+0,2
			;            TAGZ_STERN10 = 1;
	BSF   Flackerlichter6+0,4
			;            TAGZ_STERN11 = 1;
	BSF   Flackerlichter6+0,5
			;            TAGZ_STERN12 = 1;
	BSF   Flackerlichter6+0,6
			;        }
			;        else 
	GOTO  m004
			;        {
			;            TAGZ_STERN1 = 0;
m003	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,3
			;            TAGZ_STERN2 = 0;
	BCF   Flackerlichter4+0,4
			;            TAGZ_STERN3 = 0;
	BCF   Flackerlichter4+0,5
			;            TAGZ_STERN4 = 0;
	BCF   Flackerlichter4+0,6
			;            TAGZ_STERN5 = 0;
	BCF   Flackerlichter4+0,7
			;            TAGZ_STERN6 = 0;
	BCF   Flackerlichter5+0,0
			;            TAGZ_STERN7 = 0;
	BCF   Flackerlichter6+0,0
			;            TAGZ_STERN8 = 0;
	BCF   Flackerlichter6+0,1
			;            TAGZ_STERN9 = 0;
	BCF   Flackerlichter6+0,2
			;            TAGZ_STERN10 = 0;
	BCF   Flackerlichter6+0,4
			;            TAGZ_STERN11 = 0;
	BCF   Flackerlichter6+0,5
			;            TAGZ_STERN12 = 0;
	BCF   Flackerlichter6+0,6
			;        }
			;
			;        Gleichheitszaehler_Stern--;
m004	BSF   0x03,RP0
	BSF   0x03,RP1
	DECF  Gleichheitszaehler_Stern,1
			;        if (Gleichheitszaehler_Stern == 0)
	MOVF  Gleichheitszaehler_Stern,1
	BTFSS 0x03,Zero_
	GOTO  m005
			;        {
			;            Gleichheitszaehler_Stern = KONST_GLEICHHEIT;
	MOVLW .5
	MOVWF Gleichheitszaehler_Stern
			;
			;            TabZaehlerTagZ1++;
	INCF  TabZaehlerTagZ1,1
			;            PWM_LED_TagZ1 = TabFlackerlicht[TabZaehlerTagZ1];
	MOVF  TabZaehlerTagZ1,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ1
			;
			;            TabZaehlerTagZ2++;
	INCF  TabZaehlerTagZ2,1
			;            PWM_LED_TagZ2 = TabFlackerlicht[TabZaehlerTagZ2];
	MOVF  TabZaehlerTagZ2,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ2
			;
			;            TabZaehlerTagZ3++;
	INCF  TabZaehlerTagZ3,1
			;            PWM_LED_TagZ3 = TabFlackerlicht[TabZaehlerTagZ3];
	MOVF  TabZaehlerTagZ3,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ3
			;
			;            TabZaehlerTagZ4++;
	INCF  TabZaehlerTagZ4,1
			;            PWM_LED_TagZ4 = TabFlackerlicht[TabZaehlerTagZ4];
	MOVF  TabZaehlerTagZ4,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ4
			;
			;            TabZaehlerTagZ5++;
	INCF  TabZaehlerTagZ5,1
			;            PWM_LED_TagZ5 = TabFlackerlicht[TabZaehlerTagZ5];
	MOVF  TabZaehlerTagZ5,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ5
			;
			;            TabZaehlerTagZ6++;
	INCF  TabZaehlerTagZ6,1
			;            PWM_LED_TagZ6 = TabFlackerlicht[TabZaehlerTagZ6];
	MOVF  TabZaehlerTagZ6,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ6
			;            
			;            TabZaehlerTagZ7++;
	INCF  TabZaehlerTagZ7,1
			;            PWM_LED_TagZ7 = TabFlackerlicht[TabZaehlerTagZ7];
	MOVF  TabZaehlerTagZ7,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ7
			;
			;            TabZaehlerTagZ8++;
	INCF  TabZaehlerTagZ8,1
			;            PWM_LED_TagZ8 = TabFlackerlicht[TabZaehlerTagZ8];
	MOVF  TabZaehlerTagZ8,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ8
			;
			;            TabZaehlerTagZ9++;
	INCF  TabZaehlerTagZ9,1
			;            PWM_LED_TagZ9 = TabFlackerlicht[TabZaehlerTagZ9];
	MOVF  TabZaehlerTagZ9,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ9
			;
			;            TabZaehlerTagZ10++;
	INCF  TabZaehlerTagZ10,1
			;            PWM_LED_TagZ10 = TabFlackerlicht[TabZaehlerTagZ10];
	MOVF  TabZaehlerTagZ10,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ10
			;
			;            TabZaehlerTagZ11++;
	INCF  TabZaehlerTagZ11,1
			;            PWM_LED_TagZ11 = TabFlackerlicht[TabZaehlerTagZ11];
	MOVF  TabZaehlerTagZ11,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ11
			;
			;            TabZaehlerTagZ12++;
	INCF  TabZaehlerTagZ12,1
			;            PWM_LED_TagZ12 = TabFlackerlicht[TabZaehlerTagZ12];
	MOVF  TabZaehlerTagZ12,W
	CALL  _const1
	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVWF PWM_LED_TagZ12
			;        }
			;    }
			;    else
m005	GOTO  m018
			;    {
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ1) TAGZ_STERN1 = 0;
m006	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ1,W
	BTFSS 0x03,Zero_
	GOTO  m007
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,3
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ2) TAGZ_STERN2 = 0;
m007	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ2,W
	BTFSS 0x03,Zero_
	GOTO  m008
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,4
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ3) TAGZ_STERN3 = 0;
m008	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ3,W
	BTFSS 0x03,Zero_
	GOTO  m009
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,5
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ4) TAGZ_STERN4 = 0;
m009	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ4,W
	BTFSS 0x03,Zero_
	GOTO  m010
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,6
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ5) TAGZ_STERN5 = 0;
m010	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ5,W
	BTFSS 0x03,Zero_
	GOTO  m011
	BCF   0x03,RP1
	BCF   Flackerlichter4+0,7
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ6) TAGZ_STERN6 = 0;
m011	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ6,W
	BTFSS 0x03,Zero_
	GOTO  m012
	BCF   0x03,RP1
	BCF   Flackerlichter5+0,0
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ7) TAGZ_STERN7 = 0;
m012	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ7,W
	BTFSS 0x03,Zero_
	GOTO  m013
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,0
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ8) TAGZ_STERN8 = 0;
m013	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ8,W
	BTFSS 0x03,Zero_
	GOTO  m014
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,1
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ9) TAGZ_STERN9 = 0;
m014	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ9,W
	BTFSS 0x03,Zero_
	GOTO  m015
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,2
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ10) TAGZ_STERN10 = 0;
m015	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ10,W
	BTFSS 0x03,Zero_
	GOTO  m016
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,4
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ11) TAGZ_STERN11 = 0;
m016	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ11,W
	BTFSS 0x03,Zero_
	GOTO  m017
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,5
			;        if (PWM_Zaehler_Stern == PWM_LED_TagZ12) TAGZ_STERN12 = 0;
m017	BSF   0x03,RP0
	BSF   0x03,RP1
	MOVF  PWM_Zaehler_Stern,W
	XORWF PWM_LED_TagZ12,W
	BTFSS 0x03,Zero_
	GOTO  m018
	BCF   0x03,RP1
	BCF   Flackerlichter6+0,6
			;    }
			;
			;    PWM_Zaehler_Stern++;
m018	BSF   0x03,RP0
	BSF   0x03,RP1
	INCF  PWM_Zaehler_Stern,1
			;    if (PWM_Zaehler_Stern == KONST_PWM_OBERGRENZE) 
	MOVF  PWM_Zaehler_Stern,W
	XORLW .32
	BTFSS 0x03,Zero_
	GOTO  m019
			;    {
			;        PWM_Zaehler_Stern = 0;
	CLRF  PWM_Zaehler_Stern
			;    }
			;}
m019	RETURN

	END


; *** KEY INFO ***

; 0x08BE P1  223 word(s) 10 % : Flackerlicht_Stern
; 0x08A0 P1   30 word(s)  1 % : Init_Flackerlicht_Stern
; 0x0800 P1  160 word(s)  7 % : _const1

; RAM usage: 41 bytes (1 local), 327 bytes free
; Maximum call level: 1
;  Codepage 0 has    1 word(s) :   0 %
;  Codepage 1 has  413 word(s) :  20 %
; Total of 414 code words (10 %)
